Attribute VB_Name = "modID3TAGV1"
Option Explicit

Public GenreArray() As String
Public Const mp3Genre = "Blues|Classic Rock|Country|" & _
"Dance|Disco|Funk|Grunge|Hip-Hop|Jazz|Metal|New Age|Oldies|" & _
"Other|Pop|R&B|Rap|Reggae|Rock|Techno|Industrial|" & _
"Alternative|Ska|Death Metal|Pranks|Soundtrack|Euro-Techno|" & _
"Ambient|Trip Hop|Vocal|Jazz&Funk|Fusion|Trance|Classical|" & _
"Instrumental|Acid|House|Game|Sound Clip|Gospel|Noise|" & _
"Alt. Rock|Bass|Soul|Punk|Space|Meditative|Instrumental Pop|" & _
"Instrumental Rock|Ethnic|Gothic|Darkwave|Techno-Industrial|" & _
"Electronic|Pop-Folk|Eurodance|Dream|Southern Rock|Comedy|" & _
"Cult|Gangsta Rap|Top 40|Christian Rap|Pop/Punk|Jungle|" & _
"Native American|Cabaret|New Wave|Phychedelic|Rave|Showtunes|" & _
"Trailer|Lo-Fi|Tribal|Acid Punk|Acid Jazz|Polka|Retro|" & _
"Musical|Rock & Roll|Hard Rock|Folk|Folk/Rock|National Folk|" & _
"Swing|Fast-Fusion|Bebob|Latin|Revival|Celtic|Blue Grass|" & _
"Avantegarde|Gothic Rock|Progressive Rock|Psychedelic Rock|" & _
"Symphonic Rock|Slow Rock|Big Band|Chorus|Easy Listening|" & _
"Acoustic|Humour|Speech|Chanson|Opera|Chamber Music|Sonata|" & _
"Symphony|Booty Bass|Primus|Porn Groove|Satire|Slow Jam|" & _
"Club|Tango|Samba|Folklore|Ballad|power Ballad|Rhythmic Soul|" & _
"Freestyle|Duet|Punk Rock|Drum Solo|A Capella|Euro-House|" & _
"Dance Hall|Goa|Drum & Bass|Club-House|Hardcore|Terror|indie|" & _
"Brit Pop|Negerpunk|Polsk Punk|Beat|Christian Gangsta Rap|" & _
"Heavy Metal|Black Metal|Crossover|Comteporary Christian|" & _
"Christian Rock|Merengue|Salsa|Trash Metal|Anime|JPop|Synth Pop"

Public Type MP3TAGV1
  title As String * 30
  Artist As String * 30
  Album As String * 30
  Year As String * 4
  Comment As String * 28
  cNull As Byte
  track As String * 1
  Genre As Byte
End Type

Public MP3FileName As String

Public Function get_ID3V1TAG(ByVal fname As String, mp3Tag As MP3TAGV1) As Boolean
  Dim flen As Long
  Dim stream As Integer
  Dim tag As String * 3

  If ext_sep(fname) = "mp3" Then
    stream = FreeFile
    Open fname For Binary As #stream
    flen = LOF(stream)
    Get #stream, flen - 127, tag
    If tag = "TAG" Then
      Get #stream, flen - 124, mp3Tag
      Close #stream
    Else
      Close #stream
      With mp3Tag
        .Year = Year(Now)
        .title = file_sep(fname, False)
        .track = Chr(Val(.title))
        .Comment = "TAG created by vbzID3TAG"
      End With
      put_ID3V1TAG fname, mp3Tag
    End If
  End If
  get_ID3V1TAG = (tag = "TAG")
End Function

Public Function put_ID3V1TAG(ByVal fname As String, mp3Tag As MP3TAGV1) As Boolean
  Dim flen As Long
  Dim stream As Integer
  Dim tag As String * 3

  On Error GoTo ErrHandle
  
  If Not file_exist(fname) Then Exit Function
  
  stream = FreeFile
  Open fname For Binary As #stream
  flen = LOF(stream)
  Get #stream, flen - 127, tag
  If tag = "TAG" Then
    Put #stream, flen - 124, mp3Tag
  Else
    Put #stream, flen + 1, "TAG"
    Put #stream, flen + 4, mp3Tag
  End If
  Close #stream
  put_ID3V1TAG = True
  Exit Function
ErrHandle:
  If Err.Number = 75 Then
    MsgBox "Datei ist schreibgeschtzt.", vbExclamation, "MP3-TAG speichern"
  Else
    If Err.Description <> "" Then
      MsgBox Err.Description, vbCritical, "MP3-TAG speichern"
    End If
  End If
  Close #stream
  put_ID3V1TAG = False
End Function

' Gibt die Erweiterung eines Dateinamens zurck, also wenn
' 'fname' = 'C:\Dateien\Dokument.doc" ist 'ext_sep' = 'doc'
Public Function ext_sep(ByVal fname As String) As String
  If Len(fname) > 0 Then
    ext_sep = LCase(Mid$(fname, InStrRev(fname, ".") + 1))
  Else
    ext_sep = ""
  End If
End Function

' Prft auf Existenz der bergebenen Datei. Hierbei werden
' auch die Attribute Hidden und System mit eingebunden!
Public Function file_exist(ByVal file As String) As Boolean
  On Local Error GoTo FuncError
  If (file = "") Then
    file_exist = False
    Exit Function
  End If
  file_exist = (Dir(file, vbNormal + vbHidden + vbSystem) <> "")
  Exit Function
FuncError:
  file_exist = False
End Function

Public Function file_sep(ByVal Path As String, Optional extension As Boolean = True) As String
  Dim i As Long
  
  file_sep = Mid$(Path, InStrRev(Path, "\") + 1)
  ' ggf. Extension vom Dateinamen trennen:
  If Not extension Then
    i = InStrRev(file_sep, ".") - 1
    If i > 0 Then file_sep = Left$(file_sep, i)
  End If
End Function

' Gibt bei kompletter Dateinamenbergabe
' Laufwerk und Pfad mit abschlieenden '\' zurck:
Public Function path_sep(ByVal fname As String) As String
  path_sep = Left$(fname, InStrRev(fname, "\"))
End Function

